{% extends "base.html" %}
{% load static %}
{% block css %}

<link rel="stylesheet" type="text/css" href="{% static 'css/select2.min.css' %}">
<link rel="stylesheet" type="text/css" href="{% static 'css/select2-bootstrap.css' %}">
<link rel="stylesheet" type="text/css" href="{% static 'css/pmd-select2.css' %}">
<link href="{% static 'css/timeline.css' %}" rel="stylesheet">


{% endblock css  %}

{% block title %}

<h1>Nueva Rúbrica</h1>

<ol class="breadcrumb">
    <li>
        <a style="cursor: default; color: white;">Dashboard</a>
    </li>
    <li>
        <a style="cursor: default; color: white;">Evaluación</a>
    </li>
    <li class="active">Nueva Rúbrica</li>
</ol>

{% endblock title %}

{% block content %}

<div class="row">
    <div class="col-lg-12">
        <div class="card">
            <header class="card-heading card-blue">
                <h2 class="card-title">Información: </h2>
            </header>
            <div class="card-body">
                <div class="row">
                    <div class="col-md-4">
                        <div class="form-group">
                            <label for="id_title" class="control-label">Título: </label>
                            <input class="form-control" id="id_title" name="title" type="text" required="">
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="form-group">
                            <label for="id_carreer" class="control-label">Carrera: </label>
                            <select class="form-control" name="carreer" id="id_carreer">
                                {{html | safe}}
                            </select>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="form-group">
                            <label for="id_cantidadsemanas" class="control-label">Cantidad de Semanas: </label>
                            <input class="form-control" id="id_cantidadsemanas" max=20 min=0 name="cantidadsemanas" type="number" required="">
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-4 col-md-offset-8">
                        <div class="has-success">
                            <div class="checkbox">
                                <label>
                                <input type="checkbox" id="desem" value="option1" name="desem" checked>
                                    ¿Evaluar desempeño?
                                </label>
                            </div>
                        </div>
                    </div>
                    <div class="col-md-12">
                        <div class="form-group">
                            <label for="id_description" class="control-label">Descripción: </label>
                            <textarea class="form-control" id="id_description" name="description" rows="5" required=""></textarea>
                        </div>
                    </div>
                </div> 
            </div>
        </div>
    </div>
    <div class="col-lg-12 col-md-12">
        <div class="card">
            <header class="card-heading card-blue">
                <h2 class="card-title">Configuración de Sesiones</h2>
            </header>
            <div class="card-body">
                <div class="row">
                    <div class="col-md-12 col-xs-12">
                        <div class="stepwizard">
                            <div class="stepwizard-row" id="timeline">
                            </div>
                        </div>
                    </div>
                    <div class="col-md-12 col-xs-12" id="hitos" style="display:none">
                        <h2>Ponderaciones:</h2>
                        <form id="ponderations_form">
                            {% csrf_token %}
                            <div class="row" id="ponderations">
                                
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="col-md-12">
        <a type="button" id="create_rubric" class="btn btn-block btn-primary">Crear Rúbrica</a>
    </div>
</div>


{% endblock content %}


{% block javascript %}
<script src="{% static 'js/pmd-select2.js' %}"></script>
<script src="{% static 'js/global.js' %}"></script>
<script src="{% static 'js/select2.min.js' %}"></script>
<script>

$(document).ready(function(){
    $("#id_carreer").select2();
    $("#id_cantidadsemanas").change(function(){
        var hitos = $("#hitos");
        if (hitos.is(":hidden")){
            hitos.show();
        }
        html = "";
        for (i = 1; i <= $(this).val(); i++) {
        html += '<div class="stepwizard-step">\
                    <button type="button" id="' + i + '" class="btn btn-success btn-circle" value="s" style="margin-top:0%">' + i + '</button>\
                </div>';
        }
        $("#timeline").html(html);
        for (u = 1; u <= $(this).val(); u++){
            id = "#" + u;
            $(id).popover({
            placement: 'top',
            html: 'true',
            content :  '<button value="s" data-h="' + u + '" class="btn btn-block s btn-success">Semana</button>\
                        <button value="h" data-h="' + u + '" class="btn btn-block s btn-warning">Hito</button>\
                        <button value="a" data-h="' + u + '" class="btn btn-block s btn-danger">ABET</button>'
            });
        }
    
    });
    
    $(document).on("click", ".s", function() {
        var value = $(this).val();
        var id = "#" + $(this).attr("data-h");
        if(value == "s"){
            if($(id).val() == "a"){
                $(id).attr("class"," ");
                $(id).val("s_a")
                $(id).addClass("btn btn-circle btn-success semana_abet");
            }
            else{
                $(id).attr("class"," ");
                $(id).addClass("btn btn-circle btn-success");
                $(id).val(value);
            }

        }
        else if(value == "h"){
            if($(id).val() == "a"){
                $(id).attr("class"," ");
                $(id).val("h_a")
                $(id).addClass("btn btn-circle btn-primary hito_abet");
            }
            else{
                $(id).attr("class"," ");
                $(id).addClass("btn btn-circle btn-warning");
                $(id).val(value);
            }
        }
        else if(value == "a"){
            if($(id).val() == "s"){
                $(id).attr("class"," ");
                $(id).val("s_a")
                $(id).addClass("btn btn-circle btn-primary semana_abet");
            }
            else if($(id).val() == "h"){
                $(id).attr("class"," ");
                $(id).val("h_a")
                $(id).addClass("btn btn-circle btn-primary hito_abet");
            }
            else{
                $(id).attr("class"," ");
                $(id).addClass("btn btn-circle btn-danger");
                $(id).val(value);
            }
        }
        var hitos = $("button[value='h']").length - 1 + $("button[value='h_a']").length;
        var html = ""
        for (i=0;i<hitos;i++) {
            html = html +'<div class="col-md-2 col-xs-2">\
                    <div class="form-group m-0">\
                        <label for="ponderacion-'+i+'">Hito '+(i+1)+':</label>\
                        <input id="ponderacion-'+i+'" name="ponderacion-'+i+'" class="form-control input-mask hito_pond" data-mask="00%" placeholder="Ej: 50%" autocomplete="off" maxlength="2" type="text"></input>\
                    </div>\
                </div>';
            }
        if ($("#desem").is(":checked")){
            html = html + '<div class="col-md-2 col-xs-2">\
                    <div class="form-group m-0">\
                        <label for="desem_pond">Desempeño:</label>\
                        <input id="desem_pond" name="desem_pond" class="form-control input-mask hito_pond" data-mask="00%" placeholder="Ej: 50%" autocomplete="off" maxlength="2" type="text"></input>\
                    </div>\
                </div>';
        } 
        $("#ponderations").html(html);
    });
    $('html').on('mouseup', function(e) {
    if(!$(e.target).closest('.popover').length) {
        $('.popover').each(function(){
            $(this.previousSibling).popover('hide');
        });
    }
    });
    
    
    
    $("#create_rubric").click(function() {
        var suma_hitos = 0;
        $(".hito_pond").each(function(){
            suma_hitos = suma_hitos + parseInt($(this).val());
        })
        if (suma_hitos == 100){
            var sesiones = [];
            var id = "";
            var valor = "";
            var termino = $("#id_cantidadsemanas").val();

			var data = $('#ponderations_form').serializeArray();
    
            for(p=1;p <= termino; p++){
                id = "#" + p;
                valor = $(id).val();
                sesiones.push(valor);
                
            }
            sesiones = JSON.stringify(sesiones);            
            
            var data = {
                csrfmiddlewaretoken: "{{csrf_token}}",
                sessions: sesiones,
                desem: $("#desem").is(":checked"),
                title: $("#id_title").val(),
                carreer: $("#id_carreer").val(),
                description: $("#id_description").val(),
                desem_pond: $("#desem_pond").val(),

            }
            console.log(data);
            termino = $(".hito_pond").length
            
            for (i=0;i<termino;i++) {
                console.log("Entre: "+i);
                id = "#ponderacion-"+i;
                var valor = $(id).val();
                data["ponderacion-"+i] = valor;
                console.log(data);

            }

            data['termino'] = termino;
            $.post("{% url 'planning_rubric_create' %}",data,function(response){
                window.location = "/dashboard/planning/rubric_details/" + response.pk
            });
        } else {
            swal("Error!","El porcentaje total de sus ponderaciones es: "+suma_hitos+". Debe ser 100%","error")
        }

        
        
    });

});

</script>

{% endblock javascript %}
